import rclpy
from rclpy.node import Node
from active_bo_msgs.msg import DMP
from geometry_msgs.msg import Pose
import numpy as np


class DMPPublisher(Node):

    def __init__(self):
        super().__init__('dmp_test_publisher')
        self.publisher_ = self.create_publisher(DMP, 'franka_iml_experiment/dmps', 10)
        timer_period = 10  # seconds
        self.timer = self.create_timer(timer_period, self.timer_callback)

    def timer_callback(self):
        msg = DMP()

        end = [0.5, 0.5, 0., 0., 0., 0., 0.]
        msg.end_point = end
        msg.time = 10.0
        msg.nr_bfs = 10

        # Assuming you want to send zero weights for the test.
        # Modify if needed.
        msg.p_x = list(np.random.rand(10))
        msg.p_y = list(np.random.rand(10))
        # msg.p_z = [0.0] * 10
        # msg.o_x = [0.0] * 10
        # msg.o_y = [0.0] * 10
        # msg.o_z = [0.0] * 10
        # msg.o_w = [0.0] * 10

        self.publisher_.publish(msg)
        self.get_logger().info('Publishing DMP message for testing')


def main(args=None):
    rclpy.init(args=args)
    publisher = DMPPublisher()
    rclpy.spin(publisher)
    publisher.destroy_node()
    rclpy.shutdown()


if __name__ == '__main__':
    main()
